diff --git a/Documentation/devicetree/bindings/arm/omap/omap.yaml b/Documentation/devicetree/bindings/arm/omap/omap.yaml
new file mode 100644
index 0000000000000..cf07a7a7df279
--- /dev/null
+++ b/Documentation/devicetree/bindings/arm/omap/omap.yaml
@@ -0,0 +1,174 @@
+# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
+%YAML 1.2
+---
+$id: http://devicetree.org/schemas/arm/omap/omap.yaml#
+$schema: http://devicetree.org/meta-schemas/core.yaml#
+
+title: Texas Instruments OMAP SoC architecture device tree bindings
+
+maintainers:
+  - Tony Lindgren <tony@atomide.com>
+
+description: |
+  Platforms based on Texas Instruments OMAP SoC architecture.
+
+properties:
+  $nodename:
+    const: '/'
+  compatible:
+    oneOf:
+
+      - description: TI OMAP2420 SoC based platforms
+        items:
+          - enum:
+              - ti,omap2420-h4 # TI OMAP2420 H4 board
+              - nokia,n800 # Nokia N800
+              - nokia,n810 # Nokia N810
+              - nokia,n810-wimax # Nokia N810 WiMax
+          - const: ti,omap2420
+          - const: ti,omap2
+
+      - description: TI OMAP2430 SoC based platforms
+        items:
+          - enum:
+              - ti,omap2430-sdp # TI OMAP2430 SDP
+          - const: ti,omap2430
+          - const: ti,omap2
+
+      - description: TI OMAP3430 SoC based platforms
+        items:
+          - enum:
+              - logicpd,dm3730-som-lv-devkit # LogicPD Zoom OMAP35xx SOM-LV Development Kit
+              - logicpd,dm3730-torpedo-devkit # LogicPD Zoom OMAP35xx Torpedo Development Kit
+              - ti,omap3430-sdp # TI OMAP3430 SDP
+              - ti,omap3-beagle # TI OMAP3 BeagleBoard
+              - compulab,omap3-cm-t3530 # CompuLab CM-T3530
+              - timll,omap3-devkit8000 # TimLL OMAP3 Devkit8000
+              - ti,omap3-evm # TI OMAP35XX EVM (TMDSEVM3530)
+              - ti,omap3-ldp # TI OMAP3430 LDP (Zoom1 Labrador)
+              - nokia,omap3-n900 # Nokia N900
+          - const: ti,omap3430
+          - const: ti,omap3
+
+      - description: TI OMAP3630 SoC based platforms
+        items:
+          - enum:
+              - logicpd,dm3730-som-lv-devkit # LogicPD Zoom DM3730 SOM-LV Development Kit
+              - logicpd,dm3730-torpedo-devkit # LogicPD Zoom DM3730 Torpedo + Wireless Development Kit
+              - ti,omap3-beagle-xm # TI OMAP3 BeagleBoard xM
+              - compulab,omap3-cm-t3730 # CompuLab CM-T3730
+              - amazon,omap3-echo # Amazon Echo (first generation)
+              - ti,omap3-evm-37xx # TI OMAP37XX EVM (TMDSEVM3730)
+              - ti,omap3-gta04 # OMAP3 GTA04
+              - nokia,omap3-n9 # Nokia N9
+              - nokia,omap3-n950 # Nokia N950
+              - lg,omap3-sniper # LG Optimus Black
+              - ti,omap3-zoom3 # TI Zoom3
+          - const: ti,omap3630
+          - const: ti,omap3
+
+      - description: TI AM35 SoC based platforms
+        items:
+          - enum:
+              - teejet,mt_ventoux # TeeJet Mt.Ventoux
+              - ti,am3517-craneboard # TI AM3517 CraneBoard (TMDSEVM3517)
+              - ti,am3517-evm # TI AM3517 EVM (AM3517/05 TMDSEVM3517)
+              - compulab,omap3-sbc-t3517 # CompuLab SBC-T3517 with CM-T3517
+          - const: ti,am3517
+          - const: ti,omap3
+
+      - description: TI OMAP4430 SoC based platforms
+        items:
+          - enum:
+              - motorola,droid4 # Motorola Droid 4 XT894
+              - motorola,droid-bionic # Motorola Droid Bionic XT875
+              - amazon,omap4-kc1 # Amazon Kindle Fire (first generation)
+              - ti,omap4-panda # TI OMAP4 PandaBoard
+              - ti,omap4-sdp # TI OMAP4 SDP board
+          - const: ti,omap4430
+          - const: ti,omap4
+
+      - description: TI OMAP4460 SoC based platforms
+        items:
+          - enum:
+              - ti,omap4-panda-es # TI OMAP4 PandaBoard-ES
+          - const: ti,omap4460
+          - const: ti,omap4
+
+      - description: TI OMAP543 SoC based platforms
+        items:
+          - enum:
+              - compulab,omap5-cm-t54 # CompuLab CM-T54
+              - isee,omap5-igep0050 # IGEPv5
+              - ti,omap5-uevm # TI OMAP5 uEVM board
+          - const: ti,omap5
+
+      - description: TI AM33 SoC based platforms
+        items:
+          - enum:
+              - ti,am335x-bone # TI AM335x BeagleBone
+              - compulab,cm-t335 # CompuLab CM-T335
+              - ti,am335x-evm # TI AM335x EVM
+              - ti,am335x-evmsk # TI AM335x EVM-SK
+              - bosch,am335x-guardian # Bosch AM335x Guardian
+              - ti,am3359-icev2 # TI AM3359 ICE-V2
+              - novatech,am335x-lxm # NovaTech OrionLXm
+              - moxa,uc-2101 # Moxa UC-2101
+              - moxa,uc-8100-me-t # Moxa UC-8100-ME-T
+              - gumstix,am335x-pepper # Gumstix Pepper
+              - tcl,am335x-sl50 # Toby Churchill SL50 Series
+          - pattern: '^ti,am33(5[1246789]|xx)$' # ti,am33xx is legacy please use full SoC name
+
+      - description: TI AM43 SoC based platforms
+        items:
+          - enum:
+              - compulab,am437x-cm-t43 # CompuLab CM-T43
+              - ti,am437x-gp-evm # TI AM437x GP EVM
+              - ti,am437x-idk-evm # TI AM437x Industrial Development Kit
+              - ti,am437x-sk-evm # TI AM437x SK EVM
+          - pattern: '^ti,am4372[26789]$'
+          - const: ti,am43
+
+      - description: TI AM57 SoC based platforms
+        items:
+          - enum:
+              - beagle,am5729-beagleboneai # BeagleBoard.org BeagleBone AI
+              - compulab,cl-som-am57x # CompuLab CL-SOM-AM57x
+              - ti,am5718-idk # TI AM5718 IDK
+              - ti,am5728-idk # TI AM5728 IDK
+              - ti,am5748-idk # TI AM5748 IDK
+          - pattern: '^ti,am57[0124][689]$'
+          - const: ti,am57
+
+      - description: TI DRA7 SoC based platforms
+        items:
+          - enum:
+              - ti,dra718-evm # TI DRA718 EVM
+              - ti,dra722-evm # TI DRA722 EVM
+              - ti,dra742-evm # TI DRA742 EVM
+              - ti,dra762-evm # TI DRA762 EVM
+          - pattern: '^ti,dra7[12456][024568p]$'
+          - const: ti,dra7
+
+additionalProperties: true
+
+examples:
+  - |
+    / {
+        model = "TI OMAP2430 SDP (Software Development Board)";
+        compatible = "ti,omap2430-sdp", "ti,omap2430", "ti,omap2";
+
+        #address-cells = <1>;
+        #size-cells = <1>;
+    };
+
+  - |
+    / {
+        model = "TI DRA762 EVM";
+        compatible = "ti,dra762-evm", "ti,dra762", "ti,dra7";
+
+        #address-cells = <1>;
+        #size-cells = <1>;
+    };
+
+...